#include "main.h"


#define BIT_TIME	104		// 9600 Baud


#ifdef RX_INVERT
#define get_rxd()	(RXD_PIN == 0)
#else
#define get_rxd()	(RXD_PIN == 1)
#endif


u8 srx_tmp;
u8 srx_data;
u8 srx_mask;
volatile u8 srx_done;


void suart_init( void )
{
  srx_done = 0;

  srx_mask = 0;				// also change direction flag
  PCMSK = 1<<RXD_INT;			// enable start detection pin
  GIMSK = 1<<PCIE;

  TCCR1 = 0;
  GTCCR = 0;
  OCR1A = BIT_TIME;
  OCR1C = BIT_TIME;
  TIMSK = 1<<OCIE1A;
}


u8 sgetchar( void )
{
  while( !srx_done );
  srx_done = 0;
  return srx_data;
}


ISR( PCINT0_vect )
{
  if( get_rxd() == 0 ){			// if start bit
    TCNT1 = 256 - (BIT_TIME/2);         // 1.5 bit time until compare
    TCCR1 = 1<<CTC1^1<<CS12;		// start T1 with XTAL / 8
    srx_tmp = 0;			// clear bit storage
    srx_mask = 1;			// start with LSB
    PCMSK = 0;				// disable start detection
  }
}


ISR( TIM1_COMPA_vect )
{
  if( srx_mask ){
    if( get_rxd() == 1 )
      srx_tmp |= srx_mask;
    srx_mask <<= 1;
    return;
  }
  if( get_rxd() == 1 ){			// Stop bit valid
    srx_done = 1;			// mark rx data valid
    srx_data = srx_tmp;			// store rx data
    TCCR1 = 0;				// stop T1
    PCMSK = 1<<RXD_INT;			// enable further start detection
  }
}
